# Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

_CL_=
CL=
LIBPATH=
LINK=
LOG_BUILD_COMMANDLINES=

.SUFFIXES:

blunder: BLUNDER.DOS BLUNDER.EXE

clean:
	ERASE BLUNDER.DOS BLUNDER.OBJ

clobber: clean
	ERASE BLUNDER.EXE

BLUNDER.EXE: BLUNDER.OBJ # BLUNDER.DOS
	LINK.EXE /LINK /BASE:65536 /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEFAULTLIB:USER32.LIB /EMITTOOLVERSIONINFO:NO /ENTRY:wmainCRTStartup /FIXED /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:4.0 /OUT:$@ /RELEASE /STUB:BLUNDER.DOS /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /VERSION:0.815 $**

BLUNDER.OBJ: BLUNDER.MAK
	CL.EXE /Brepro /c /Fo$@ /GA /GF /Gw /Gy /nologo /O2 /Os /Oy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ms644927.aspx
// https://msdn.microsoft.com/en-us/library/ms674887.aspx
// https://msdn.microsoft.com/en-us/library/ms644931.aspx

const	LPCWSTR	szMessage[WM_USER + 1] =
{
	L"WM_NULL",				// 0x0000
	L"WM_CREATE",				// 0x0001
	L"WM_DESTROY",				// 0x0002
	L"WM_MOVE",				// 0x0003
	L"wm_sizewait",
	L"WM_SIZE",				// 0x0005
	L"WM_ACTIVATE",				// 0x0006
	L"WM_SETFOCUS",				// 0x0007
	L"WM_KILLFOCUS",			// 0x0008
	L"wm_setvisible",
	L"WM_ENABLE",				// 0x000A
	L"WM_SETREDRAW",			// 0x000B
	L"WM_SETTEXT",				// 0x000C
	L"WM_GETTEXT",				// 0x000D
	L"WM_GETTEXTLENGTH",			// 0x000E
	L"WM_PAINT",				// 0x000F
	L"WM_CLOSE",				// 0x0010
	L"WM_QUERYENDSESSION",			// 0x0011
	L"WM_QUIT",				// 0x0012
	L"WM_QUERYOPEN",			// 0x0013
	L"WM_ERASEBKGND",			// 0x0014
	L"WM_SYSCOLORCHANGE",			// 0x0015
	L"WM_ENDSESSION",			// 0x0016
	L"wm_systemerror",
	L"WM_SHOWWINDOW",			// 0x0018
	L"WM_CTLCOLOR",				// 0x0019
	L"WM_SETTINGCHANGE",			// 0x001A
	L"WM_DEVMODECHANGE",			// 0x001B
	L"WM_ACTIVATEAPP",			// 0x001C
	L"WM_FONTCHANGE",			// 0x001D
	L"WM_TIMECHANGE",			// 0x001E
	L"WM_CANCELMODE",			// 0x001F
	L"WM_SETCURSOR",			// 0x0020
	L"WM_MOUSEACTIVATE",			// 0x0021
	L"WM_CHILDACTIVATE",			// 0x0022
	L"WM_QUEUESYNC",			// 0x0023
	L"WM_GETMINMAXINFO",			// 0x0024
	L"wm_logoff",
	L"WM_PAINTICON",			// 0x0026
	L"WM_ICONERASEBKGND",			// 0x0027
	L"WM_NEXTDLGCTL",			// 0x0028
	L"wm_alttabactive",
	L"WM_SPOOLERSTATUS",			// 0x002A
	L"WM_DRAWITEM",				// 0x002B
	L"WM_MEASUREITEM",			// 0x002C
	L"WM_DELETEITEM",			// 0x002D
	L"WM_VKEYTOITEM",			// 0x002E
	L"WM_CHARTOITEM",			// 0x002F
	L"WM_SETFONT",				// 0x0030
	L"WM_GETFONT",				// 0x0031
	L"WM_SETHOTKEY",			// 0x0032
	L"WM_GETHOTKEY",			// 0x0033
	L"wm_shellnotify",
	L"wm_isactiveicon",
	L"wm_queryparkicon",
	L"WM_QUERYDRAGICON",			// 0x0037
	L"wm_winhelp",
	L"WM_COMPAREITEM",			// 0x0039
	L"wm_fullscreen",
	L"wm_clientshutdown",
	L"wm_ddemlevent",
	L"WM_GETOBJECT",			// 0x003D
	L"wm_activateshellwindow",
	L"wm_calcscroll",
	L"wm_testing",
	L"WM_COMPACTING",			// 0x0041
	L"wm_otherwindowcreated",
	L"wm_otherwindowdestroyed",
	L"WM_COMMNOTIFY",			// 0x0044
	L"wm_mediastatuschange",
	L"WM_WINDOWPOSCHANGING",		// 0x0046
	L"WM_WINDOWPOSCHANGED",			// 0x0047
	L"WM_POWER",				// 0x0048
	L"wm_copyglobaldata",
	L"WM_COPYDATA",				// 0x004A
	L"WM_CANCELJOURNAL",			// 0x004B
	L"wm_logonnotify",
	L"wm_keyf1",
	L"WM_NOTIFY",				// 0x004E
	L"wm_access_window",
	L"WM_INPUTLANGCHANGEREQUEST",		// 0x0050
	L"WM_INPUTLANGCHANGE",			// 0x0051
	L"WM_TCARD",				// 0x0052
	L"WM_HELP",				// 0x0053
	L"WM_USERCHANGED",			// 0x0054
	L"WM_NOTIFYFORMAT",			// 0x0055
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_finaldestroy",
	L"wm_measureitem_clientdata",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_CONTEXTMENU",			// 0x007B
	L"WM_STYLECHANGING",			// 0x007C
	L"WM_STYLECHANGED",			// 0x007D
	L"WM_DISPLAYCHANGE",			// 0x007E
	L"WM_GETICON",				// 0x007F
	L"WM_SETICON",				// 0x0080
	L"WM_NCCREATE",				// 0x0081
	L"WM_NCDESTROY",			// 0x0082
	L"WM_NCCALCSIZE",			// 0x0083
	L"WM_NCHITTEST",			// 0x0084
	L"WM_NCPAINT",				// 0x0085
	L"WM_NCACTIVATE",			// 0x0086
	L"WM_GETDLGCODE",			// 0x0087
	L"WM_SYNCPAINT",			// 0x0088
	L"wm_synctask",
	NULL,
	L"wm_kludgeminrect",
	L"wm_lpkdrawswitchwnd",
	NULL,
	NULL,
	NULL,
	L"wm_uahdestroywindow",
	L"wm_uahdrawmenu",
	L"wm_uahdrawmenuitem",
	L"wm_uahinitmenu",
	L"wm_uahmeasuremenuitem",
	L"wm_uahncpaintmenupopup",
	L"wm_uahupdate",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_NCMOUSEMOVE",			// 0x00A0
	L"WM_NCLBUTTONDOWN",			// 0x00A1
	L"WM_NCLBUTTONUP",			// 0x00A2
	L"WM_NCLBUTTONDBLCLK",			// 0x00A3
	L"WM_NCRBUTTONDOWN",			// 0x00A4
	L"WM_NCRBUTTONUP",			// 0x00A5
	L"WM_NCRBUTTONDBLCLK",			// 0x00A6
	L"WM_NCMBUTTONDOWN",			// 0x00A7
	L"WM_NCMBUTTONUP",			// 0x00A8
	L"WM_NCMBUTTONDBLCLK",			// 0x00A9
	NULL,
	L"WM_NCXBUTTONDOWN",			// 0x00AB
	L"WM_NCXBUTTONUP",			// 0x00AC
	L"WM_NCXBUTTONDBLCLK",			// 0x00AD
	L"wm_ncuahdrawcaption",
	L"wm_ncuahdrawframe",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_INPUT_DEVICE_CHANGE",		// 0x00FE
	L"WM_INPUT",				// 0x00FF
	L"WM_KEYDOWN",				// 0x0100
	L"WM_KEYUP",				// 0x0101
	L"WM_CHAR",				// 0x0102
	L"WM_DEADCHAR",				// 0x0103
	L"WM_SYSKEYDOWN",			// 0x0104
	L"WM_SYSKEYUP",				// 0x0105
	L"WM_SYSCHAR",				// 0x0106
	L"WM_SYSDEADCHAR",			// 0x0107
	L"wm_yomichar",
	L"WM_UNICHAR",				// 0x0109
	L"WM_CONVERTREQUEST",
	L"WM_CONVERTRESULT",
	L"WM_INTERIM",
	L"WM_IME_STARTCOMPOSITION",		// 0x010D
	L"WM_IME_ENDCOMPOSITION",		// 0x010E
	L"WM_IME_COMPOSITION",			// 0x010F
	L"WM_INITDIALOG",			// 0x0110
	L"WM_COMMAND",				// 0x0111
	L"WM_SYSCOMMAND",			// 0x0112
	L"WM_TIMER",				// 0x0113
	L"WM_HSCROLL",				// 0x0114
	L"WM_VSCROLL",				// 0x0115
	L"WM_INITMENU",				// 0x0116
	L"WM_INITMENUPOPUP",			// 0x0117
	L"wm_systimer",
	L"WM_GESTURE",				// 0x0119
	L"WM_GESTURENOTIFY",			// 0x011A
	L"wm_gestureinput",
	L"wm_gesturenotified",
	NULL,
	NULL,
	L"WM_MENUSELECT",			// 0x011F
	L"WM_MENUCHAR",				// 0x0120
	L"WM_ENTERIDLE",			// 0x0121
	L"WM_MENURBUTTONUP",			// 0x0122
	L"WM_MENUDRAG",				// 0x0123
	L"WM_MENUGETOBJECT",			// 0x0124
	L"WM_UNINITMENUPOPUP",			// 0x0125
	L"WM_MENUCOMMAND",			// 0x0126
	L"WM_CHANGEUISTATE",			// 0x0127
	L"WM_UPDATEUISTATE",			// 0x0128
	L"WM_QUERYUISTATE",			// 0x0129
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_lbtrackpoint",
	L"WM_CTLCOLORMSGBOX",			// 0x0132
	L"WM_CTLCOLOREDIT",			// 0x0133
	L"WM_CTLCOLORLISTBOX",			// 0x0134
	L"WM_CTLCOLORBTN",			// 0x0135
	L"WM_CTLCOLORDLG",			// 0x0136
	L"WM_CTLCOLORSCROLLBAR",		// 0x0137
	L"WM_CTLCOLORSTATIC",			// 0x0138
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_MOUSEMOVE",			// 0x0200
	L"WM_LBUTTONDOWN",			// 0x0201
	L"WM_LBUTTONUP",			// 0x0202
	L"WM_LBUTTONDBLCLK",			// 0x0203
	L"WM_RBUTTONDOWN",			// 0x0204
	L"WM_RBUTTONUP",			// 0x0205
	L"WM_RBUTTONDBLCLK",			// 0x0206
	L"WM_MBUTTONDOWN",			// 0x0207
	L"WM_MBUTTONUP",			// 0x0208
	L"WM_MBUTTONDBLCLK",			// 0x0209
	L"WM_MOUSEWHEEL",			// 0x020A
	L"WM_XBUTTONDOWN",			// 0x020B
	L"WM_XBUTTONUP",			// 0x020C
	L"WM_XBUTTONDBLCLK",			// 0x020D
	L"WM_MOUSEHWHEEL",			// 0x020E
	L"WM_MOUSELAST",
	L"WM_PARENTNOTIFY",			// 0x0210
	L"WM_ENTERMENULOOP",			// 0x0211
	L"WM_EXITMENULOOP",			// 0x0212
	L"WM_NEXTMENU",				// 0x0213
	L"WM_SIZING",				// 0x0214
	L"WM_CAPTURECHANGED",			// 0x0215
	L"WM_MOVING",				// 0x0216
	NULL,
	L"WM_POWERBROADCAST",			// 0x0218
	L"WM_DEVICECHANGE",			// 0x0219
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_MDICREATE",			// 0x0220
	L"WM_MDIDESTROY",			// 0x0221
	L"WM_MDIACTIVATE",			// 0x0222
	L"WM_MDIRESTORE",			// 0x0223
	L"WM_MDINEXT",				// 0x0224
	L"WM_MDIMAXIMIZE",			// 0x0225
	L"WM_MDITILE",				// 0x0226
	L"WM_MDICASCADE",			// 0x0227
	L"WM_MDIICONARRANGE",			// 0x0228
	L"WM_MDIGETACTIVE",			// 0x0229
	L"wm_dropobject",
	L"wm_querydropobject",
	L"wm_begindrag",
	L"wm_dragloop",
	L"wm_dragselect",
	L"wm_dragmove",
	L"WM_MDISETMENU",			// 0x0230
	L"WM_ENTERSIZEMOVE",			// 0x0231
	L"WM_EXITSIZEMOVE",			// 0x0232
	L"WM_DROPFILES",			// 0x0233
	L"WM_MDIREFRESHMENU",			// 0x0234
	NULL,
	NULL,
	NULL,
	L"WM_POINTERDEVICECHANGE",		// 0x0238
	L"WM_POINTERDEVICEINRANGE",		// 0x0239
	L"WM_POINTERDEVICEOUTOFRANGE",		// 0x023A
	L"wm_stopinertia",
	L"wm_endinertia",
	L"wm_edgyinertia",
	NULL,
	NULL,
	L"WM_TOUCH",				// 0x0240
	L"WM_NCPOINTERUPDATE",			// 0x0241
	L"WM_NCPOINTERDOWN",			// 0x0242
	L"WM_NCPOINTERUP",			// 0x0243
	L"wm_ncpointerlast",
	L"WM_POINTERUPDATE",			// 0x0245
	L"WM_POINTERDOWN",			// 0x0246
	L"WM_POINTERUP",			// 0x0247
	L"wm_pointer_reserved",
	L"WM_POINTERENTER",			// 0x0249
	L"WM_POINTERLEAVE",			// 0x024A
	L"WM_POINTERACTIVATE",			// 0x024B
	L"WM_POINTERCAPTURECHANGED",		// 0x024C
	L"WM_TOUCHHITTESTING",			// 0x024D
	L"WM_POINTERWHEEL",			// 0x024E
	L"WM_POINTERHWHEEL",			// 0x024F
	L"WM_POINTERHITTEST",			// 0x0250
	L"WM_POINTERROUTEDTO",			// 0x0251
	L"WM_POINTERROUTEDAWAY",		// 0x0252
	L"WM_POINTERROUTEDRELEASED",		// 0x0253
	NULL,
	NULL,
	NULL,
	L"wm_pointerlast",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_visibilitychanged",
	L"wm_viewstatechanged",
	L"wm_unregister_window_services",
	L"wm_consolidated",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_IME_REPORT",
	L"WM_IME_SETCONTEXT",			// 0x0281
	L"WM_IME_NOTIFY",			// 0x0282
	L"WM_IME_CONTROL",			// 0x0283
	L"WM_IME_COMPOSITIONFULL",		// 0x0284
	L"WM_IME_SELECT",			// 0x0285
	L"WM_IME_CHAR",				// 0x0286
	L"WM_IME_SYSTEM",
	L"WM_IME_REQUEST",			// 0x0288
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_IME_KEYDOWN",			// 0x0290
	L"WM_IME_KEYUP",			// 0x0291
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_kanjilast",
	L"WM_NCMOUSEHOVER",			// 0x02A0
	L"WM_MOUSEHOVER",			// 0x02A1
	L"WM_NCMOUSELEAVE",			// 0x02A2
	L"WM_MOUSELEAVE",			// 0x02A3
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_trackmouseevent_last",
	NULL,
	L"WM_WTSSESSION_CHANGE",		// 0x02B1
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_TABLET_FIRST",			// 0x02C0
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_TABLET_ADDED",			// 0x02C8
	L"WM_TABLET_DELETED",			// 0x02C9
	NULL,
	L"WM_TABLET_FLICK",			// 0x02CB
	L"WM_TABLET_QUERYSYSTEMGESTURESTATUS",
	L"wm_flickinternal",
	L"wm_brightnesschanged",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_TABLET_LAST",			// 0x02DF
	L"WM_DPICHANGED",			// 0x02E0
	NULL,
	L"WM_DPICHANGED_BEFOREPARENT",
	L"WM_DPICHANGED_AFTERPARENT",
	L"WM_GETDPISCALEDSIZE",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_CUT",				// 0x0300
	L"WM_COPY",				// 0x0301
	L"WM_PASTE",				// 0x0302
	L"WM_CLEAR",				// 0x0303
	L"WM_UNDO",				// 0x0304
	L"WM_RENDERFORMAT",			// 0x0305
	L"WM_RENDERALLFORMATS",			// 0x0306
	L"WM_DESTROYCLIPBOARD",			// 0x0307
	L"WM_DRAWCLIPBOARD",			// 0x0308
	L"WM_PAINTCLIPBOARD",			// 0x0309
	L"WM_VSCROLLCLIPBOARD",			// 0x030A
	L"WM_SIZECLIPBOARD",			// 0x030B
	L"WM_ASKCBFORMATNAME",			// 0x030C
	L"WM_CHANGECBCHAIN",			// 0x030D
	L"WM_HSCROLLCLIPBOARD",			// 0x030E
	L"WM_QUERYNEWPALETTE",			// 0x030F
	L"WM_PALETTEISCHANGING",		// 0x0310
	L"WM_PALETTECHANGED",			// 0x0311
	L"WM_HOTKEY",				// 0x0312
	L"wm_popupsystemmenu",
	L"wm_hookmsg",
	L"wm_exitprocess",
	L"wm_wakethread",
	L"WM_PRINT",				// 0x0317
	L"WM_PRINTCLIENT",			// 0x0318
	L"WM_APPCOMMAND",			// 0x0319
	L"WM_THEMECHANGED",			// 0x031A
	L"wm_uahinit",
	L"wm_desktopnotify",
	L"WM_CLIPBOARDUPDATE",			// 0x031D
	L"WM_DWMCOMPOSITIONCHANGED",		// 0x031E
	L"WM_DWMNCRENDERINGCHANGED",		// 0x031F
	L"WM_DWMCOLORIZATIONCOLORCHANGED",	// 0x0320
	L"WM_DWMWINDOWMAXIMIZEDCHANGE",		// 0x0321
	L"wm_dwmexileframe",
	L"WM_DWMSENDICONICTHUMBNAIL",		// 0x0323
	L"wm_magnification_started",
	L"wm_magnification_ended",
	L"WM_DWMSENDICONICLIVEPREVIEWBITMAP",	// 0x0326
	L"wm_dwmthumbnailsizechanged",
	L"wm_magnification_output",
	L"wm_bsdrdata",
	L"wm_dwmtransitionstatechanged",
	NULL,
	L"wm_keyboardcorrectioncallout",
	L"wm_keyboardcorrectionaction",
	L"wm_uiaction",
	L"wm_routed_ui_event",
	L"wm_measurecontrol",
	L"wm_getactiontext",
	NULL,
	L"wm_forwardkeydown",
	L"wm_forwardkeyup",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_GETTITLEBARINFOEX",		// 0x033F
	L"wm_notifywow",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_HANDHELDFIRST",			// 0x0358
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_HANDHELDLAST",			// 0x035F
	L"WM_QUERYAFXWNDPROC",			// 0x0360
	L"WM_SIZEPARENT",
	L"WM_SETMESSAGESTRING",
	L"WM_IDLEUPDATECMDUI",
	L"WM_INITIALUPDATE",
	L"WM_COMMANDHELP",
	L"WM_HELPHITTEST",
	L"WM_EXITHELPMODE",
	L"WM_RECALCPARENT",
	L"WM_SIZECHILD",
	L"WM_KICKIDLE",
	L"WM_QUERYCENTERWND",
	L"WM_DISABLEMODAL",
	L"WM_FLOATSTATUS",
	L"WM_ACTIVATETOPLEVEL",
	L"WM_QUERY3DCONTROLS",
	NULL,
	NULL,
	NULL,
	L"WM_SOCKET_NOTIFY",
	L"WM_SOCKET_DEAD",
	L"WM_POPMESSAGESTRING",
	L"WM_OCC_LOADFROMSTREAM",
	L"WM_OCC_LOADFROMSTORAGE",
	L"WM_OCC_INITNEW",
	L"WM_QUEUE_SENTINEL",
	L"WM_OCC_LOADFROMSTREAM_EX",
	L"WM_OCC_LOADFROMSTORAGE_EX",
	NULL,
	NULL,
	NULL,
	L"WM_AFXLAST",				// 0x037F
	L"WM_PENWINFIRST",			// 0x0380
	L"WM_RCRESULT",
	L"WM_HOOKRCRESULT",
	L"WM_PENMISCINFO",
	L"WM_SKB",
	L"WM_PENCTL",
	L"WM_PENMISC",
	L"WM_CTLINIT",
	L"WM_PENEVENT",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_PENWINLAST",			// 0x038F
	L"wm_coalesce_first",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_coalesce_last",
	L"wm_mm_first",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"WM_MM_MCINOTIFY",			// 0x03C9
	NULL,
	L"WM_MM_MCISIGNAL",			// 0x03CB
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_mm_last",
	L"WM_DDE_INITIATE",			// 0x03E0
	L"WM_DDE_TERMINATE",			// 0x03E1
	L"WM_DDE_ADVISE",			// 0x03E2
	L"WM_DDE_UNADVISE",			// 0x03E3
	L"WM_DDE_ACK",				// 0x03E4
	L"WM_DDE_DATA",				// 0x03E5
	L"WM_DDE_REQUEST",			// 0x03E6
	L"WM_DDE_POKE",				// 0x03E7
	L"WM_DDE_EXECUTE",			// 0x03E8
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_cbt_first",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	L"wm_cbt_last",
	L"WM_USER"				// 0x0400
};

__inline
LPCWSTR	WINAPI	MessageCode(UINT uMessage)
{
	// https://msdn.microsoft.com/en-us/library/ms644927.aspx
	// https://msdn.microsoft.com/en-us/library/ms674887.aspx
	// https://msdn.microsoft.com/en-us/library/ms644931.aspx

	if (uMessage < sizeof(szMessage) / sizeof(*szMessage))
		return szMessage[uMessage] != NULL ? szMessage[uMessage] : L"wm_unknown";

	// https://msdn.microsoft.com/en-us/library/ms644930.aspx

	if (uMessage < WM_APP)
		return L"WM_USER + ";

	if (uMessage < 0xC000)
		return L"WM_APP + ";

	if (uMessage > 0xFFFF)
		return L"wm_reserved + ";

	return L"wm_registered + ";
}

// https://msdn.microsoft.com/en-us/library/hh916382.aspx
// https://msdn.microsoft.com/en-us/library/ms633573.aspx

__declspec(safebuffers)
LRESULT	WINAPI	WindowProc(HWND hWindow, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	// https://msdn.microsoft.com/en-us/library/ms633572.aspx

	LRESULT	lResult = DefWindowProc(hWindow, uMessage, wParam, lParam);

	// https://msdn.microsoft.com/en-us/library/ms644937.aspx

	HANDLE	hError = GetStdHandle(STD_ERROR_HANDLE);

	// https://msdn.microsoft.com/en-us/library/ms647550.aspx

	WCHAR	szError[1024];
	DWORD	dwError = wsprintf(szError,
		                   L"DefWindowProc(0x%p, 0x%04X = %ls, 0x%p, 0x%p) returned %Id\n",
		                   hWindow, uMessage, MessageCode(uMessage), wParam, lParam, lResult);
	if (dwError > 0UL)

		// https://msdn.microsoft.com/en-us/library/ms687401.aspx

		if (!WriteConsole(hError, szError, dwError, &dwError, NULL))

			// https://msdn.microsoft.com/en-us/library/ms633591.aspx
			// https://msdn.microsoft.com/en-us/library/ms679360.aspx

			SetWindowLong(hWindow, GWL_USERDATA, GetLastError());

	if (uMessage == WM_NCDESTROY)

		// https://msdn.microsoft.com/en-us/library/ms644945.aspx
		// https://msdn.microsoft.com/en-us/library/ms633584.aspx

		PostQuitMessage(GetWindowLong(hWindow, GWL_USERDATA));

	return lResult;
}

extern	const	IMAGE_DOS_HEADER	__ImageBase;

// https://msdn.microsoft.com/en-us/library/ms633577.aspx
// https://msdn.microsoft.com/en-us/library/ff729176.aspx

const	WNDCLASSEX	wce = {sizeof(wce),
			       CS_DBLCLKS,
			       WindowProc,
			       0, 0,
			       (HINSTANCE) &__ImageBase,
			       (HICON) NULL,
			       (HCURSOR) NULL,
			       (HBRUSH) COLOR_BACKGROUND,
			       (LPCWSTR) NULL,
			       L"Blunder Demonstration Class",
			       (HICON) NULL};

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	CDECL	wmainCRTStartup(VOID)
{
	DWORD	dwError;
	LRESULT lResult;
	BOOL	bResult;
	HWND	hWindow;

	// https://msdn.microsoft.com/en-us/library/ms644958.aspx

	MSG	msg;

	// https://msdn.microsoft.com/en-us/library/ms649053.aspx
	// https://msdn.microsoft.com/en-us/library/ms633587.aspx

	ATOM	atom = RegisterClassEx(&wce);

	if (atom == 0U)
		dwError = GetLastError();
	else
	{	// https://msdn.microsoft.com/en-us/library/ms632680.aspx
		// https://msdn.microsoft.com/en-us/library/ms632600.aspx

		hWindow = CreateWindowEx(WS_EX_APPWINDOW,
		                         wce.lpszClassName,
		                         L"Blunder Demonstration Window",
		                         WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		                         CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		                         (HWND) NULL,
		                         (HMENU) NULL,
		                         wce.hInstance,
		                         NULL);
		if (hWindow == NULL)
			dwError = GetLastError();
		else
		{	// https://msdn.microsoft.com/en-us/library/ms644936.aspx

			while ((bResult = GetMessage(&msg, (HWND) NULL, WM_NULL, WM_NULL)) > 0)
			{
				// https://msdn.microsoft.com/en-us/library/ms644955.aspx

				if (TranslateMessage(&msg))
					;

				// https://msdn.microsoft.com/en-us/library/ms644934.aspx

				lResult = DispatchMessage(&msg);
			}

			// https://msdn.microsoft.com/en-us/library/ms679360.aspx

			dwError = bResult < 0 ? GetLastError() : msg.wParam;
		}

		// https://msdn.microsoft.com/en-us/library/ms644899.aspx

		if (!UnregisterClass(wce.lpszClassName, wce.hInstance))
			dwError = GetLastError();
	}

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(dwError);
}
<<NOKEEP

BLUNDER.OMF: BLUNDER.MAK
	ML.EXE /Brepro /Fo$@ /nologo /omf /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	tiny

; https://support.microsoft.com/en-us/kb/65122

e_header struct				; DOS .EXE header
e_magic	word	5A4Dh			; magic number "MZ"
e_cblp	word	stop - header		; bytes on last page of file
e_cp	word	1			; pages in file
e_crlc	word	0			; number of relocation table entries
e_cparhdr word	sizeof header / 16	; size of header in paragraphs
e_minalloc word	0			; minimum extra paragraphs needed
e_maxalloc word	65535			; maximum extra paragraphs needed
e_ss	word	0			; initial (PSP relative) SS value
e_sp	word	stack - header		; initial (SS relative) SP value
e_csum	word	0			; checksum
e_ip	word	sizeof message		; initial (CS relative) IP value
e_cs	word	0			; initial (PSP relative) CS value
e_lfarlc word	sizeof header		; file address of relocation table
e_ovno	word	0			; overlay number
e_res	word	4 dup (0)		; reserved words
e_oemid	word	5719h			; OEM identifier
e_oeminfo word	2704h			; OEM information
e_res2	word	10 dup (0)		; reserved words
e_lfanew dword	0			; file address of new exe header
e_header ends

	.code

header	e_header <>

message	byte	"(C)opyright 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>", 0Dh, 0Ah, 07h, 24h

start:
	push	cs
	pop	ds
	xor	dx, dx
	mov	ah, 09h
	int	21h

	mov	ax, 4C01h
	int	21h
stop:
	dword	20 dup (?)
stack:
	end	start
<<NOKEEP

BLUNDER.DOS: BLUNDER.MAK
	CERTUTIL.EXE /DecodeHex /F /V << $@
4D 5A 90 00 01 00 00 00 04 00 00 00 FF FF 00 00   MZ..............
E0 00 00 00 43 00 00 00 40 00 00 00 00 00 00 00   ....C...@.......
00 00 00 00 19 57 04 27 00 00 00 00 00 00 00 00   .....W.'........
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ................
28 43 29 6F 70 79 72 69 67 68 74 20 32 30 30 34   (C)opyright 2004
2D 32 30 32 35 2C 20 53 74 65 66 61 6E 20 4B 61   -2025, Stefan Ka
6E 74 68 61 6B 20 3C 73 74 65 66 61 6E 2E 6B 61   nthak <stefan.ka
6E 74 68 61 6B 40 6E 65 78 67 6F 2E 64 65 3E 0D   nthak@nexgo.de>.
0A 07 24 0E 1F 33 D2 B4 09 CD 21 B8 01 4C CD 21   .....3....!..L.!
<<NOKEEP
